var services
var selectedService

function appendService(table, service, nr){
  var mytr = tr(table)
  td(mytr, nr).className = "servicesBorder"
  td(mytr, service.title).className = "servicesBorder"
  td(mytr, service.address).className = "servicesBorder"
  td(mytr, service.type).className = "servicesBorder"
  var act = td(mytr)
  act.className = "servicesBorderRight"
  var remove = a(act, "Löschen")
  remove.href = "javascript:deleteService('" + service.address + "')"
  remove.className = "normalLink"

  addText(act, " ")

  var update = a(act, "Aktualisieren")
  update.href = "javascript:updateService('" + service.address + "', '" + service.type + "')"
  update.className = "normalLink"

  addText(act, " ")

  var edit = a(act, "Bearbeiten")
  edit.href = "javascript:editService('" + service.address + "')"
  edit.className = "normalLink"

  highlightTableRow(mytr)
}

function updateServicesTable(sortFunc){
  var table = tableBody(document.getElementById("servicesTable"))
  var header = document.getElementById("servicesTableHeader")
  while(table.firstChild) table.removeChild(table.firstChild)
  table.appendChild(header)

  var servs = []

  for(var s in services) servs[servs.length] = services[s]

  if(sortFunc){
    servs.sort(sortFunc)
  }

  var idx = 1
  for(var i = 0; i < servs.length; ++i){
    appendService(table, servs[i], idx++)
  }
}

function deleteService(address){
  if(confirm("Soll der Dienst mit der Adresse '" + address + "' und die dazugehörigen Informationsebenen wirklich gelöscht werden?")){
    removeService(address)
  }
}

function clickedRadio(){
  if(document.serviceSelectForm.serviceType[0].checked){
    if(document.serviceSelectForm.serviceAddress.value == 'http://demo.deegree.org/deegree-wfs/services'){
      document.serviceSelectForm.serviceAddress.value = 'http://demo.deegree.org/deegree-wms/services'
    }
  }else{
    if(document.serviceSelectForm.serviceAddress.value == 'http://demo.deegree.org/deegree-wms/services'){
      document.serviceSelectForm.serviceAddress.value = 'http://demo.deegree.org/deegree-wfs/services'
    }
  }
}

function selectService(){
  var select = document.serviceSelectForm.serviceSelect
  selectedService = select.options[select.selectedIndex]
}

function importService(){
  var form = document.serviceSelectForm
  addService(form.serviceAddress.value, form.serviceType[0].checked ? "wms" : "wfs")
}
